#include<bits/stdc++.h>
#define endl '\n'

typedef long long ll;

void speed()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cin.tie(nullptr);
}

struct Point
{
    ll x, y;

    Point(ll _x = 0, ll _y = 0)
    {
        x = _x;
        y = _y;
    }
};

const int MAXN = 1e5 + 10;

int n, k;
Point dot[MAXN];

void input()
{
    std::cin >> n >> k;
    for (int i = 1; i <= n; i ++)
    {
        std::cin >> dot[i].x >> dot[i].y;
    }
}

const ll inf= 4e9;
void solve_k1()
{
    ll min_x = inf, max_x = -inf, min_y = inf, max_y = -inf;
    for (int i = 1; i <= n; i ++)
    {
        min_x = std::min(min_x, dot[i].x);
        max_x = std::max(max_x, dot[i].x);
        min_y = std::min(min_y, dot[i].y);
        max_y = std::max(max_y, dot[i].y);
    }

    ll side = std::max(max_x - min_x, max_y - min_y);
    std::cout << min_x << " " << min_y << " " << side << endl;
}
void solve()
{
    input();
    if (k == 1)
        solve_k1();
}

int main()
{
    speed();
    solve();
    return 0;
}