#include<iostream>
#include<vector>
#include <bits/stdc++.h>

bool init_done = false;
using namespace std;
vector < pair < pair < int, int >, pair < int, int > > > valid_lines;

void add_line(int x1, int y1, int x2, int y2)
{
    valid_lines.push_back(make_pair(make_pair(x1, y1), make_pair(x2, y2)));
}

map < pair < int, int >, pair < int, int > > rot;

map < pair < pair < int, int >, pair < int, int > >, int > val;
void init()
{
    add_line(0, 0, 0, 1);
    add_line(0, 0, 1, 2);
    add_line(0, 0, 1, 1);
    add_line(0, 0, 2, 1);
    add_line(0, 0, 1, 0);

    add_line(0, 1, 0, 2);
    add_line(0, 1, 1, 2);
    add_line(0, 1, 2, 2);
    ///add_line(0, 1, 1, 1);
    add_line(0, 1, 2, 0);
    add_line(0, 1, 1, 0);

    add_line(0, 2, 1, 2);
    add_line(0, 2, 2, 1);
    add_line(0, 2, 1, 1);
    add_line(0, 2, 1, 0);

    add_line(1, 2, 2, 2);
    add_line(1, 2, 2, 1);
    add_line(1, 2, 2, 0);
    ///add_line(1, 2, 1, 1);
    
    add_line(2, 2, 2, 1);
    add_line(2, 2, 1, 0);
    add_line(2, 2, 1, 1);
    
    add_line(2, 1, 2, 0);
    add_line(2, 1, 1, 0);
    ///add_line(2, 1, 1, 1);

    add_line(2, 0, 1, 0);
    add_line(2, 0, 1, 1);

    ///add_line(1, 0, 1, 1);
    pair < pair < int, int >, pair < int, int > > cur;
    for (int i = 0; i < (int)(valid_lines.size()); i ++)
    {
        cur = valid_lines[i];
        if (cur.first > cur.second)
            swap(cur.first, cur.second);
        valid_lines[i] = cur;
        val[cur] = (1 << i);
    }

    rot[{0, 0}] = {2, 0};
    rot[{1, 0}] = {2, 1};
    rot[{2, 0}] = {2, 2};
    rot[{0, 1}] = {1, 0};
    rot[{1, 1}] = {1, 1};
    rot[{2, 1}] = {1, 2};
    rot[{0, 2}] = {0, 0};
    rot[{1, 2}] = {0, 1};
    rot[{2, 2}] = {0, 2};
}


vector <pair <pair <int, int>, pair <int, int>>> mark_card (int k) 
{
    if (!init_done)
    {
        init();
        init_done = true;
        std::cout << "valid lines " << valid_lines.size() << endl;
    }

    vector <pair <pair <int, int>, pair <int, int>>> res;
    for (int i = 0; i < (int)valid_lines.size(); i ++)
    {
        if ((k & (1 << (i))) > 0)
        {

            res.push_back(valid_lines[i]);
        }
    }
    int sz = valid_lines.size();
    if ((k & (1 << (sz))) > 0)
        res.push_back(make_pair(make_pair(0, 1), make_pair(1, 1)));
    else
    if ((k & (1 << (sz + 1))) > 0)
    {
        res.push_back(make_pair(make_pair(0, 1), make_pair(1, 1)));
        res.push_back(make_pair(make_pair(1, 2), make_pair(1, 1)));
    }


    res.push_back(make_pair(make_pair(1, 0), make_pair(1, 1)));
    return res;
}


int tell_card (vector <pair <pair <int, int>, pair <int, int>>> card) 
{
    if (!init_done)
    {
        init();
        init_done = true;
    }    
    vector < pair < int, int > > ds ;
    for (int i = 0; i < (int)(card.size()); i ++)
    {
        if (card[i].second == make_pair(1, 1))
            swap(card[i].first, card[i].second);

        if (card[i].first == make_pair(1, 1))
        {
            int dx = card[i].second.first - 1, dy = card[i].second.second - 1;
            if (dx < 0)
                dx *= -1;
            if (dy < 0)
                dy *= -1;
            //std::cout << "HERE " << dx << " " << dy << std::endl;
            if (dx + dy == 1)
                ds.push_back(card[i].second);
        }
    }

    //std::cout << spec.first << " " << spec.second << std::endl;

    int tp = 4;
    for (int d = 0; d < 4; d ++)
    {
        int min_x = 4, max_x = 0;
        for (pair < int, int > spec : ds)
        {
            int c;
            if (spec == make_pair(1, 0))
                c = 0 - d;
            else
            if (spec == make_pair(0, 1))
                c = 1 - d;
            else
            if (spec == make_pair(1, 2))
                c = 2 - d;
            else
            if (spec == make_pair(2, 1))
                c = 3 - d;
            else
            {
                assert(false);
            }
            if (c < 0)
                c += 4;

            min_x = min(min_x, c);
            max_x = max(max_x, c);
        }

        if (min_x == 0 && max_x != 4)
            tp = d;
    }


    ///std::cout << "TP " << tp << std::endl;

    for (int t = 0; t < tp; t ++)
    {
        for (int i = 0; i < (int)(card.size()); i ++)
        {
            pair < pair < int, int >, pair < int, int > > cur = card[i];
            cur.first = rot[cur.first];
            cur.second = rot[cur.second];
            card[i] = cur;
        }
    }



    int value = 0;
    for (int i = 0; i < (int)(card.size()); i ++)
    {
        pair < pair < int, int >, pair < int, int > > cur = card[i];
        //std::cout << "card " << cur.first.first << " " << cur.first.second << " ";
        //std::cout << cur.second.first << " " << cur.second.second << std::endl;
        value = value + val[cur];
        swap(cur.first, cur.second);
        value = value + val[cur];
    }
    int sz = valid_lines.size();
    if (ds.size() == 2)
    {
        value += (1 << sz);
    }
    else
    if (ds.size() == 3)
    {
        value += (1 << (sz + 1));
    }
    //std::cout << "value " << value << std::endl;
    return value;
}