#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 1e5 + 10;
const int INF  = 1e9;

int n, randomImeKoetoNqmaDaPolzvam;
struct Point
{
    int x, y;
};

Point p[MAXN];

void solve()
{
    int minX = INF;
    int minY = INF;
    int maxX = -INF;
    int maxY = -INF;

    for (int i = 1 ; i <= n ; ++i)
    {
        minX = std::min(minX, p[i].x);
        maxX = std::max(maxX, p[i].x);
        minY = std::min(minY, p[i].y);
        maxY = std::max(maxY, p[i].y);
    }

    std::cout << minX << ' ' << minY << ' ' << std::max(maxX - minX, maxY - minY) << '\n';
}

void input()
{
    std::cin >> n >> randomImeKoetoNqmaDaPolzvam;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> p[i].x >> p[i].y;
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}