#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

const long long inf=1e10;
 
struct point{
    int x,y;
};

struct square{
    int x,y,l;
};

int n,k,miny,maxy,minx,maxx;
point p[MAXN];

bool cmp(point fr,point sc){
    return fr.x<sc.x;
}

bool cmp2(point fr,point sc){
    return fr.y<sc.y;
}

square sol[3];

bool ok(int l,int r,long long len){
    maxx=minx=p[l].x;
    maxy=miny=p[l].y;

    int pt=r-1;
    for(int f=l;f<=r;f++){
        sol[0]={minx,miny,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){   
            pt=f-1; break;
        }
    }
    
    maxx=minx=p[pt+1].x;
    maxy=miny=p[pt+1].y;

    for(int f=pt+1;f<=r;f++){
        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){
            break;
        }

        if(f==r){
            sol[1]={minx,miny,len};
            return true;
        }
    }

    return false;
}

bool check2(int l,int r,long long len){
    sort(p+l+1,p+r+1,cmp);
    if(ok(l,r,len))return true;

    reverse(p+l+1,p+r+1);
    if(ok(l,r,len))return true;

    sort(p+l+1,p+r+1,cmp2);
    if(ok(l,r,len))return true;

    reverse(p+l+1,p+r+1);
    if(ok(l,r,len))return true;

    return false;
}

bool check3(long long len){

    sort(p+1,p+n+1,cmp);

    maxx=minx=p[1].x;
    maxy=miny=p[1].y;

    for(int f=1;f<=n;f++){
        sol[2]={maxx-len,maxy-len,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){
            if(check2(f,n,len)){
                return true;
            }
            break;
        }

        if(f==n)return true;
    }

    sort(p+1,p+n+1,cmp);   
    reverse(p+1,p+n+1); 

    maxx=minx=p[1].x;
    maxy=miny=p[1].y;

    for(int f=1;f<=n;f++){
        sol[2]={minx,miny,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){
            if(check2(f,n,len)){
                return true;
            }
            break;
        }

        if(f==n)return true;
    }


    sort(p+1,p+n+1,cmp2);

    maxx=minx=p[1].x;
    maxy=miny=p[1].y;

    for(int f=1;f<=n;f++){
        sol[2]={maxx-len,maxy-len,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){
            if(check2(f,n,len)){
                return true;
            }
            break;
        }

        if(f==n)return true;
    }

    sort(p+1,p+n+1,cmp2);   
    reverse(p+1,p+n+1); 

    maxx=minx=p[1].x;
    maxy=miny=p[1].y;

    for(int f=1;f<=n;f++){
        sol[2]={maxx-len,maxy-len,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){
            if(check2(f,n,len)){
                return true;
            }
            break;
        }

        if(f==n)return true;
    }

    return false;
}

void solve3(){
    long long l=0,r=inf,tt;
    
    while(l+1<r){
        tt=(l+r)/2;
        if(check3(tt)){
            r=tt;
        }else{
            l=tt;
        }
    }

    check3(r);
    for(int i=0;i<3;i++){
        cout<<sol[i].x<<" "<<sol[i].y<<" "<<sol[i].l<<"\n";
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<=n;i++){
        cin>>p[i].x>>p[i].y;
    }

    //if(k==1)solve1();
    //if(k==2)solve2();
    if(k==3)solve3();


    return 0;
}