#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

vector< pair< pair<int,int> , pair<int,int> > > edge;
map< pair< pair<int,int> , pair<int,int> > , int> revv;

void calc(){
    edge.clear();

    for(int i=0;i<3;i++){
        for(int f=0;f<3;f++){
            for(int k=0;k<3;k++){
                for(int s=0;s<3;s++){
                    if(i>k or (i==k and f>s))continue;
                    if(abs(i-k)+abs(f-s)==1){
                        if(i==0 and f==0 and k==0)continue;
                        if(i==0 and f==2 and s==2)continue;
                        if(i==2 and f==1 and k==2)continue;
                        if(i==1 and f==0 and s==0)continue;
                    }

                    if(i==k and abs(f-s)==2)continue;
                    if(f==s and abs(i-k)==2)continue;
        

                    if(abs(i-k)+abs(f-s)==4)continue;
                    if(abs(i-k)+abs(f-s)==0)continue;

                    edge.push_back({{i,f},{k,s}});
                    revv[{{i,f},{k,s}}]=edge.size()-1;
                }
            }
        }
    }
}

vector <pair <pair <int, int>, pair <int, int> > > mark_card (int k){
    calc();

    vector <pair <pair <int, int>, pair <int, int> > > res;
    res.push_back({{0,0},{0,1}});

    for(int i=0;(1<<i)<=k;i++){
        if(((1<<i)&k))res.push_back(edge[i]);
    }

    edge.clear();
    revv.clear();

    return res;
}

map< pair<int,int> , pair<int,int> > to;

void mapp(){
    to[{0,0}]={2,0}; to[{0,1}]={1,0}; to[{0,2}]={0,0};
    to[{1,0}]={2,1}; to[{1,1}]={1,1}; to[{1,2}]={0,1};
    to[{2,0}]={2,2}; to[{2,1}]={1,2}; to[{2,2}]={0,2};
}

vector <pair <pair <int, int>, pair <int, int> > > rotate(vector <pair <pair <int, int>, pair <int, int> > > s){
    for(int i=0;i<s.size();i++){
        s[i].first=to[s[i].first];
        s[i].second=to[s[i].second];

        if(s[i].first.first>s[i].second.first)swap(s[i].first,s[i].second);
        if(s[i].first.first==s[i].second.first and s[i].first.second>s[i].second.second)swap(s[i].first,s[i].second);
    }

    return s;
}

vector <pair <pair <int, int>, pair <int, int> > > bogo(vector <pair <pair <int, int>, pair <int, int> > > s){
    random_shuffle(s.begin(),s.end());

    for(int i=0;i<rand()%10;i++){
        s=rotate(s);
    }

    for(pair <pair <int, int>, pair <int, int> > &d:s){
        if(rand()%2==0)swap(d.first,d.second);
    }

    return s;
}

int tell_card (vector <pair <pair <int, int>, pair <int, int> > > card){
    int deg=0;

    calc();
    mapp();

    for(pair< pair<int,int> , pair<int,int> > &s:card){
        if(s.first.first>s.second.first)swap(s.first,s.second);
        if(s.first.first==s.second.first and s.first.second>s.second.second)swap(s.first,s.second);

        pair< pair<int,int> , pair<int,int> > p;
        p={{0,0},{0,1}};
        if(s==p)deg=0;
        p={{0,2},{1,2}};
        if(s==p)deg=90;
        p={{2,1},{2,2}};
        if(s==p)deg=180;
        p={{1,0},{2,0}};
        if(s==p)deg=270;
    }

    while(deg>0){
        card=rotate(card);
        deg-=90;
    }

    int ans=0;
    for(pair< pair<int,int> , pair<int,int> > s:card){

        pair< pair<int,int> , pair<int,int> > p;
        p={{0,0},{0,1}};
        if(s==p)continue;

        ans+=(1<<revv[s]);
    }

    edge.clear();
    revv.clear();

    return ans;
}

/*
int main(){
    mapp();

    vector <pair <pair <int, int>, pair <int, int> > > s[40];
    for(int i=1;i<=30;i++){
        s[i]=mark_card(i);
    }

    for(int i=1;i<=30;i++){
        cout<<tell_card(bogo(s[i]))<<" ";
    }
}*/
