#include<bits/stdc++.h>
#define endl '\n'
#define x first
#define y second
#define int long long

using namespace std;

typedef long long ll;

const int MAXN=1e5+5;

struct Sq
{
    ll x,y,l;
    Sq() {};
    Sq(ll _x,ll _y,ll _l)
    {
        x=_x;
        y=_y;
        l=_l;
    }
};

int n,k;
pair<int,int> p[MAXN];

int getMaxX(int l,int r)
{
    int ret=p[l].x;
    for(int i=l+1;i<=r;i++) ret=max(ret, p[i].x);
    return ret;
}
int getMaxY(int l,int r)
{
    int ret=p[l].y;
    for(int i=l+1;i<=r;i++) ret=max(ret, p[i].y);
    return ret;
}
int getMinX(int l,int r)
{
    int ret=p[l].x;
    for(int i=l+1;i<=r;i++) ret=min(ret, p[i].x);
    return ret;
}
int getMinY(int l,int r)
{
    int ret=p[l].y;
    for(int i=l+1;i<=r;i++) ret=min(ret, p[i].y);
    return ret;
}

pair<Sq,Sq> solveX(int ind)
{
    int mnx1=getMinX(1,ind-1);
    int mny1=getMinY(1,ind-1);
    int mxx1=getMaxX(1,ind-1);
    int mxy1=getMaxY(1,ind-1);

    int mnx2=getMinX(ind,n);
    int mny2=getMinY(ind,n);
    int mxx2=getMaxX(ind,n);
    int mxy2=getMaxY(ind,n);

    int l1=1, l2=1;
    l1=max(l1, mxx1-mnx1);
    l1=max(l1, mxy1-mny1);
    l2=max(l2, mxx2-mnx2);
    l2=max(l2, mxy2-mny2);

    return {Sq(mxx1-l1,mny1,l1), Sq(mnx2,mny2,l2)};
}

pair<Sq,Sq> solveY(int ind)
{
    int mnx1=getMinX(1,ind-1);
    int mny1=getMinY(1,ind-1);
    int mxx1=getMaxX(1,ind-1);
    int mxy1=getMaxY(1,ind-1);

    int mnx2=getMinX(ind,n);
    int mny2=getMinY(ind,n);
    int mxx2=getMaxX(ind,n);
    int mxy2=getMaxY(ind,n);

    int l1=1, l2=1;
    l1=max(l1, mxx1-mnx1);
    l1=max(l1, mxy1-mny1);
    l2=max(l2, mxx2-mnx2);
    l2=max(l2, mxy2-mny2);

    return {Sq(mnx1,mxy1-l1,l1), Sq(mnx2,mny2,l2)};
}

bool cmpY(pair<int,int> a,pair<int,int> b)
{
    if(a.y==b.y) return a.x<b.x;
    return a.y<b.y;
}

signed main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>k;
for(int i=1;i<=n;i++) cin>>p[i].x>>p[i].y;

if(n==1)
{
    cout<<p[1].x<<" "<<p[1].y<<" "<<1<<endl;
    if(k==2) cout<<p[1].x+2<<" "<<p[1].y+2<<" "<<1<<endl;
    return 0;
}

int mnx,mxx,mny,mxy;
mnx=getMinX(1,n);
mny=getMinY(1,n);
mxx=getMaxX(1,n);
mxy=getMaxY(1,n);
int l=1;
l=max(l,mxx-mnx);
l=max(l,mxy-mny);

if(k==1)
{
    cout<<mnx<<" "<<mny<<" "<<l<<endl;
    return 0;
}

if(k==2)
{
    pair<Sq,Sq> ans={Sq(mnx,mny,l), Sq(mxx+1,mxy+1,1)};
    int bst=l;

    sort(p+1,p+n+1);
    for(int i=1;i<=n;i++)
    {
        pair<int,int> mn1={getMinX(1,i), getMinY(1,i)};
        pair<int,int> mx1={getMaxX(1,i), getMaxY(1,i)};
        pair<int,int> mn2={getMinX(i+1,n), getMinY(i+1,n)};
        pair<int,int> mx2={getMaxX(i+1,n), getMaxY(i+1,n)};
        int l1=max(1LL, max(mx1.x-mn1.x, mx1.y-mn1.y));
        int l2=max(1LL, max(mx2.x-mn2.x, mx2.y-mn2.y));

        //if(l1>l2) break;
        if(max(l1,l2)<bst)
        {
            ans={Sq(mx1.x-l1, mn1.y, l1), Sq(mn2.x, mn2.y, l2)};
            bst=max(l1,l2);
        }
    }

    sort(p+1,p+n+1, cmpY);
    for(int i=1;i<=n;i++)
    {
        pair<int,int> mn1={getMinX(1,i), getMinY(1,i)};
        pair<int,int> mx1={getMaxX(1,i), getMaxY(1,i)};
        pair<int,int> mn2={getMinX(i+1,n), getMinY(i+1,n)};
        pair<int,int> mx2={getMaxX(i+1,n), getMaxY(i+1,n)};
        int l1=max(1LL, max(mx1.x-mn1.x, mx1.y-mn1.y));
        int l2=max(1LL, max(mx2.x-mn2.x, mx2.y-mn2.y));

        //if(l1>l2) break;
        if(max(l1,l2)<bst)
        {
            ans={Sq(mn1.x, mx1.y-l1, l1), Sq(mn2.x, mn2.y, l2)};
            bst=max(l1,l2);
        }
    }

    cout<<ans.first.x<<" "<<ans.first.y<<" "<<ans.first.l<<endl;
    cout<<ans.second.x<<" "<<ans.second.y<<" "<<ans.second.l<<endl;

    return 0;
}

return 0;
}

/*
7 2
0 0
1 4
4 -3
4 2
6 6
5 -1
-3 -3
*/
