#include<bits/stdc++.h>
#define endl '\n'
#define x first
#define y second
#define int long long

using namespace std;

typedef long long ll;

const int MAXN=1e5+5;

struct Sq
{
    ll x,y,l;
    Sq() {};
    Sq(ll _x,ll _y,ll _l)
    {
        x=_x;
        y=_y;
        l=_l;
    }
};

int n,k;
pair<int,int> p[MAXN];
pair<int,int> mn1[MAXN];
pair<int,int> mx1[MAXN];
pair<int,int> mn2[MAXN];
pair<int,int> mx2[MAXN];

int getMaxX(int l,int r)
{
    int ret=p[l].x;
    for(int i=l+1;i<=r;i++) ret=max(ret, p[i].x);
    return ret;
}
int getMaxY(int l,int r)
{
    int ret=p[l].y;
    for(int i=l+1;i<=r;i++) ret=max(ret, p[i].y);
    return ret;
}
int getMinX(int l,int r)
{
    int ret=p[l].x;
    for(int i=l+1;i<=r;i++) ret=min(ret, p[i].x);
    return ret;
}
int getMinY(int l,int r)
{
    int ret=p[l].y;
    for(int i=l+1;i<=r;i++) ret=min(ret, p[i].y);
    return ret;
}

bool cmpY(pair<int,int> a,pair<int,int> b)
{
    if(a.y==b.y) return a.x<b.x;
    return a.y<b.y;
}

signed main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>k;
for(int i=1;i<=n;i++) cin>>p[i].x>>p[i].y;

if(n==1)
{
    cout<<p[1].x<<" "<<p[1].y<<" "<<1<<endl;
    if(k==2) cout<<p[1].x+2<<" "<<p[1].y+2<<" "<<1<<endl;
    return 0;
}

int mnx,mxx,mny,mxy;
mnx=getMinX(1,n);
mny=getMinY(1,n);
mxx=getMaxX(1,n);
mxy=getMaxY(1,n);
int l=1;
l=max(l,mxx-mnx);
l=max(l,mxy-mny);

if(k==1)
{
    cout<<mnx<<" "<<mny<<" "<<l<<endl;
    return 0;
}

if(k==2)
{
    pair<Sq,Sq> ans={Sq(mnx,mny,l), Sq(mxx+1,mxy+1,1)};
    int bst=l;

    sort(p+1,p+n+1);
    mn1[1]=p[1];
    mx1[1]=p[1];
    for(int i=2;i<=n;i++)
    {
        mn1[i].x=min(mn1[i-1].x, p[i].x);
        mn1[i].y=min(mn1[i-1].y, p[i].y);
        mx1[i].x=max(mx1[i-1].x, p[i].x);
        mx1[i].y=max(mx1[i-1].y, p[i].y);
    }
    mn2[n]=p[n];
    mx2[n]=p[n];
    for(int i=n-1;i>=1;i--)
    {
        mn2[i].x=min(mn2[i+1].x, p[i].x);
        mn2[i].y=min(mn2[i+1].y, p[i].y);
        mx2[i].x=max(mx2[i+1].x, p[i].x);
        mx2[i].y=max(mx2[i+1].y, p[i].y);
    }
    for(int i=1;i<n;i++)
    {
        int l1=max(1LL, max(mx1[i].x-mn1[i].x, mx1[i].y-mn1[i].y));
        int l2=max(1LL, max(mx2[i+1].x-mn2[i+1].x, mx2[i+1].y-mn2[i+1].y));

        if(max(l1,l2)<bst)
        {
            ans={Sq(mx1[i].x-l1, mn1[i].y, l1), Sq(mn2[i+1].x, mn2[i+1].y, l2)};
            bst=max(l1,l2);
        }
    }

    sort(p+1,p+n+1, cmpY);
    mn1[1]=p[1];
    mx1[1]=p[1];
    for(int i=2;i<=n;i++)
    {
        mn1[i].x=min(mn1[i-1].x, p[i].x);
        mn1[i].y=min(mn1[i-1].y, p[i].y);
        mx1[i].x=max(mx1[i-1].x, p[i].x);
        mx1[i].y=max(mx1[i-1].y, p[i].y);
    }
    mn2[n]=p[n];
    mx2[n]=p[n];
    for(int i=n-1;i>=1;i--)
    {
        mn2[i].x=min(mn2[i+1].x, p[i].x);
        mn2[i].y=min(mn2[i+1].y, p[i].y);
        mx2[i].x=max(mx2[i+1].x, p[i].x);
        mx2[i].y=max(mx2[i+1].y, p[i].y);
    }
    for(int i=1;i<n;i++)
    {
        int l1=max(1LL, max(mx1[i].x-mn1[i].x, mx1[i].y-mn1[i].y));
        int l2=max(1LL, max(mx2[i+1].x-mn2[i+1].x, mx2[i+1].y-mn2[i+1].y));

        if(max(l1,l2)<bst)
        {
            ans={Sq(mn1[i].x, mx1[i].y-l1, l1), Sq(mn2[i+1].x, mn2[i+1].y, l2)};
            bst=max(l1,l2);
        }
    }

    cout<<ans.first.x<<" "<<ans.first.y<<" "<<ans.first.l<<endl;
    cout<<ans.second.x<<" "<<ans.second.y<<" "<<ans.second.l<<endl;

    return 0;
}

return 0;
}

/*
7 2
0 0
1 4
4 -3
4 2
6 6
5 -1
-3 -3
*/
