#include<bits/stdc++.h>
#include<iostream>
#include<vector>
#define fi first
#define se second

using namespace std;

typedef pair<int,int> pii;

const int TYPE1=(1<<24)-1;
const int TYPE2=(1<<25)-1;
const int TYPE3=(1<<25)+(1<<24)-1;

//int cntQ=0;
map<pair<pii,pii>, int> m;
pair<pii,pii> dc[30];
bool used[30];
int rot[30];

void getRots()
{
    rot[1]=2;
    rot[2]=3;
    rot[3]=4;
    rot[4]=1;

    rot[5]=7;
    rot[6]=8;
    rot[7]=10;
    rot[8]=9;
    rot[9]=11;
    rot[10]=12;
    rot[11]=6;
    rot[12]=5;

    rot[13]=15;
    rot[14]=16;
    rot[15]=18;
    rot[16]=17;
    rot[17]=19;
    rot[18]=20;
    rot[19]=14;
    rot[20]=13;

    rot[21]=22;
    rot[22]=23;
    rot[23]=24;
    rot[24]=21;

    rot[25]=28;
    rot[26]=27;
    rot[27]=25;
    rot[28]=26;
}

void getCodes()
{
    m[{{0,0},{1,1}}]=1;
    dc[1]={{0,0},{1,1}};
    m[{{1,1},{2,0}}]=2;
    dc[2]={{1,1},{2,0}};
    m[{{1,1},{2,2}}]=3;
    dc[3]={{1,1},{2,2}};
    m[{{0,2},{1,1}}]=4;
    dc[4]={{0,2},{1,1}};

    m[{{0,0},{1,0}}]=5;
    dc[5]={{0,0},{1,0}};
    m[{{1,0},{2,0}}]=6;
    dc[6]={{1,0},{2,0}};
    m[{{2,0},{2,1}}]=7;
    dc[7]={{2,0},{2,1}};
    m[{{2,1},{2,2}}]=8;
    dc[8]={{2,1},{2,2}};
    m[{{0,2},{1,2}}]=9;
    dc[9]={{0,2},{1,2}};
    m[{{1,2},{2,2}}]=10;
    dc[10]={{1,2},{2,2}};
    m[{{0,0},{0,1}}]=11;
    dc[11]={{0,0},{0,1}};
    m[{{0,1},{0,2}}]=12;
    dc[12]={{0,1},{0,2}};

    m[{{0,0},{1,2}}]=13;
    dc[13]={{0,0},{1,2}};
    m[{{0,0},{2,1}}]=14;
    dc[14]={{0,0},{2,1}};
    m[{{0,1},{2,0}}]=15;
    dc[15]={{0,1},{2,0}};
    m[{{1,2},{2,0}}]=16;
    dc[16]={{1,2},{2,0}};
    m[{{0,1},{2,2}}]=17;
    dc[17]={{0,1},{2,2}};
    m[{{1,0},{2,2}}]=18;
    dc[18]={{1,0},{2,2}};
    m[{{0,2},{1,0}}]=19;
    dc[19]={{0,2},{1,0}};
    m[{{0,2},{2,1}}]=20;
    dc[20]={{0,2},{2,1}};

    m[{{1,0},{2,1}}]=21;
    dc[21]={{1,0},{2,1}};
    m[{{1,2},{2,1}}]=22;
    dc[22]={{1,2},{2,1}};
    m[{{0,1},{1,2}}]=23;
    dc[23]={{0,1},{1,2}};
    m[{{0,1},{1,0}}]=24;
    dc[24]={{0,1},{1,0}};

    m[{{1,0},{1,1}}]=25;
    dc[25]={{1,0},{1,1}};
    m[{{1,1},{1,2}}]=26;
    dc[26]={{1,1},{1,2}};
    m[{{0,1},{1,1}}]=27;
    dc[27]={{0,1},{1,1}};
    m[{{1,1},{2,1}}]=28;
    dc[28]={{1,1},{2,1}};

    getRots();
}


void _rotate(vector<int>& seg) ///
{
    for(int i=0;i<seg.size();i++)
    {
        seg[i]=rot[seg[i]];
    }
}

int deseg1[(1<<24)+5];
int deseg2[(1<<24)+5];
int val1[(1<<24)+5];
int val2[(1<<24)+5];

void getVal()
{
    int ptr=0;
    for(int i=0;i<(1<<24);i++)
    {
        if(i>0 && val1[i]>0) continue;
        vector<int> seg;
        for(int j=0;(1<<j)<=i;j++)
        {
            if(i&(1<<j)) seg.push_back(j+5);
        }
        deseg1[ptr]=i;
        val1[i]=ptr;
        _rotate(seg);
        _rotate(seg);
        int cur=0;
        for(auto x: seg) cur+=(1<<(x-5));
        val1[cur]=ptr;
        ptr++;
    }

    ptr=0;
    for(int i=0;i<(1<<24);i++)
    {
        if(i>0 && val2[i]>0) continue;
        vector<int> seg;
        for(int j=0;(1<<j)<=i;j++)
        {
            if(i&(1<<j)) seg.push_back(j+5);
        }
        deseg2[ptr]=i;
        val2[i]=ptr;
        for(int j=0;j<3;j++)
        {
            _rotate(seg);
            int cur=0;
            for(auto x: seg) cur+=(1<<(x-5));
            val2[cur]=ptr;
        }
        ptr++;
    }
}

vector<pair<pii,pii> > code1(int k)
{
    vector<int> seg;
    seg.push_back(1);
    seg.push_back(2);
    seg.push_back(3);

    for(int i=0;i<24;i++)
    {
        if(k&(1<<i)) seg.push_back(i+5);
    }

    vector<pair<pii,pii> > ret;
    for(auto x: seg)
    {
        ret.push_back(dc[x]);
    }

    return ret;
}

vector<pair<pii,pii> > code2(int k)
{
    k-=(1<<24);

    vector<int> seg;
    seg.push_back(1);
    seg.push_back(2);

    for(int i=0;i<24;i++)
    {
        if(k&(1<<i)) seg.push_back(i+5);
    }

    vector<pair<pii,pii> > ret;
    for(auto x: seg)
    {
        ret.push_back(dc[x]);
    }

    return ret;
}

vector<pair<pii,pii> > code3(int k)
{
    k-=(1<<25);

    vector<int> seg;
    seg.push_back(1);

    for(int i=0;i<24;i++)
    {
        if(k&(1<<i)) seg.push_back(i+5);
    }

    vector<pair<pii,pii> > ret;
    for(auto x: seg)
    {
        ret.push_back(dc[x]);
    }

    return ret;
}

vector<pair<pii,pii> > code4(int k)
{
    k-=(1<<25);
    k-=(1<<24);

    vector<int> seg;
    if(k>=(1<<23))
    {
        seg.push_back(1);
        seg.push_back(3);
        for(int i=0;i<25;i++)
        {
            if(deseg1[k]&&(1<<i)) seg.push_back(i+5);
        }
    }
    else if(k>=(1<<22))
    {
        for(int i=0;i<25;i++)
        {
            if(deseg2[k]&&(1<<i)) seg.push_back(i+5);
        }
    }
    else
    {
        seg.push_back(1);
        seg.push_back(2);
        seg.push_back(3);
        seg.push_back(4);
        for(int i=0;i<25;i++)
        {
            if(deseg2[k]&&(1<<i)) seg.push_back(i+5);
        }
    }

    vector<pair<pii,pii> > ret;
    for(auto x: seg)
    {
        ret.push_back(dc[x]);
    }

    return ret;
}

int cntQr=0;

std::vector <std::pair <std::pair <int, int>, std::pair <int, int>>> mark_card (int k)
{
    if(cntQr==0) getVal();
    cntQr++;

    getCodes();

    if(k<=TYPE1) return code1(k);
    else if(k<=TYPE2) return code2(k);
    else if(k<=TYPE3) return code3(k);
    else code4(k);
}

vector<int> getSeg(vector<pair<pii,pii> > card)
{
    vector<int> ret;
    for(auto cur: card)
    {
        ret.push_back(m[cur]);
    }
    return ret;
}


int tell_card (std::vector <std::pair <std::pair <int, int>, std::pair <int, int>>> card)
{
    if(cntQr==0) getVal();
    cntQr++;

    getCodes();

    for(auto &cur: card)
    {
        if(cur.fi>cur.se) swap(cur.fi, cur.se);
    }
    vector<int> seg=getSeg(card);

    //for(auto x: seg) cout<<x<<" "; cout<<endl;

    memset(used,0,sizeof(used));
    for(auto x: seg) used[x]=1;

    int ans=0;

    int cntUsed=0;
    for(int i=1;i<=4;i++) if(used[i]) cntUsed++;

    if(cntUsed==3)
    {
        int rots=0;
        if(!used[1]) rots=3;
        if(!used[2]) rots=2;
        if(!used[3]) rots=1;
        for(int i=0;i<rots;i++) _rotate(seg);

        for(auto x: seg)
        {
            if(x<=4) continue;
            else ans+=(1<<(x-5));
        }
    }

    else if((used[1] && used[2]) ||
            (used[2] && used[3]) ||
            (used[3] && used[4]) ||
            (used[4] && used[1]))
    {
        int rots=0;
        if(used[2] && used[3]) rots=3;
        if(used[3] && used[4]) rots=2;
        if(used[4] && used[1]) rots=1;
        for(int i=0;i<rots;i++) _rotate(seg);

        //for(auto x: seg) cout<<x<<" "; cout<<endl;

        ans+=(1<<24);
        for(auto x: seg)
        {
            if(x<=4) continue;
            ans+=(1<<(x-5));
        }
    }

    else if(cntUsed==1)
    {
        int rots=0;
        if(used[2]) rots=3;
        if(used[3]) rots=2;
        if(used[4]) rots=1;
        for(int i=0;i<rots;i++) _rotate(seg);

        ans+=(1<<25);
        for(auto x: seg)
        {
            if(x<=4) continue;
            ans+=(1<<(x-5));
        }
    }

    else
    {
        if(cntUsed==2)
        {
            ans+=(1<<25);
            ans+=(1<<24);
            int cur=0;
            for(auto x: seg)
            {
                if(x<=4) continue;
                cur+=(1<<(x-5));
            }
            ans+=val1[cur];
        }
        else if(cntUsed==0)
        {
            ans+=(1<<25);
            ans+=(1<<24);
            ans+=(1<<23);
            int cur=0;
            for(auto x: seg)
            {
                if(x<=4) continue;
                cur+=(1<<(x-5));
            }
            ans+=val2[cur];
        }
        else if(cntUsed==4)
        {
            ans+=(1<<25);
            ans+=(1<<24);
            ans+=(1<<23);
            ans+=(1<<22);
            int cur=0;
            for(auto x: seg)
            {
                if(x<=4) continue;
                cur+=(1<<(x-5));
            }
            ans+=val2[cur];
        }
    }

    return ans;
}
