#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=150005;

int n,m;
int c[MAXN];
int d[MAXN];
vector<int> adj[MAXN];
bool found=0;
bool used[MAXN];

void dfs(int v,int clr,int par)
{
    if(c[v]==clr)
    {
        found=1;
        return;
    }
    if(used[v]) return;

    for(auto u: adj[v])
    {
        if(u==par) continue;
        if(c[u]<clr) continue;
        dfs(u,clr,v);
        if(found) return;
    }
}

void init()
{
    for(int i=1;i<=n;i++) adj[i].clear();
    for(int i=1;i<=n;i++) used[i]=0;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

int tt;
cin>>tt;
while(tt--)
{
    cin>>n>>m; init();
    for(int i=1;i<=n;i++) cin>>c[i];
    for(int i=1;i<=n;i++) cin>>d[i];
    for(int i=0;i<m;i++)
    {
        int u,v;
        cin>>u>>v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    bool fl=0;
    for(int i=1;i<=n;i++)
    {
        if(d[i]>c[i])
        {
            cout<<0<<endl;
            fl=1;
            break;
        }
    }
    if(fl) continue;
    if(n==1)
    {
        if(d[1]!=c[1]) cout<<0<<endl;
        else cout<<1<<endl;
        continue;
    }

    fl=0;
    for(int i=n;i>0;i--)
    {
        for(int j=1;j<=n;j++)
        {
            found=0;
            if(d[j]==i && c[j]>i)
            {
                dfs(j,i,0);
                if(!found)
                {
                    fl=1;
                    break;
                }
                else used[j]=1;
            }
        }
        if(fl) break;
    }
    if(fl) cout<<0<<endl;
    else cout<<1<<endl;
}

return 0;
}
/*
1
5 4
4 3 5 2 5
3 3 2 2 4
1 2
1 3
3 4
3 5
*/
