#include "Lgrader.cpp"
#include <bits/stdc++.h>

using namespace std;

struct seg
{
    int a,b,c,d;
    seg(){};
    seg(int a, int b, int c, int d) : a(a), b(b), c(c), d(d) {}
};

seg ots[7][4];
seg pos[28];
map<pair<pair<int,int>,pair<int,int> > , int >mymap;

void make_ots()
{
    ots[0][0] = {1,1,1,0};
    ots[0][1] = {1,1,2,1};
    ots[0][2] = {1,1,1,2};
    ots[0][3] = {1,1,0,1};

    ots[1][0] = {1,1,0,0};
    ots[1][1] = {1,1,2,0};
    ots[1][2] = {1,1,2,2};
    ots[1][3] = {1,1,0,2};

    ots[2][0] = {0,0,1,0};
    ots[2][1] = {2,0,2,1};
    ots[2][2] = {2,2,1,2};
    ots[2][3] = {0,2,0,1};

    ots[3][0] = {1,0,2,0};
    ots[3][1] = {2,1,2,2};
    ots[3][2] = {1,2,0,2};
    ots[3][3] = {0,1,0,0};

    ots[4][0] = {1,0,2,1};
    ots[4][1] = {2,1,1,2};
    ots[4][2] = {1,2,0,1};
    ots[4][3] = {0,1,1,0};

    ots[5][0] = {0,0,1,2};
    ots[5][1] = {1,0,2,2};
    ots[5][2] = {0,1,2,0};
    ots[5][3] = {0,2,2,1};

    ots[6][0] = {0,0,2,1};
    ots[6][1] = {0,1,2,2};
    ots[6][2] = {0,2,1,0};
    ots[6][3] = {1,2,2,0};
}
pair< pair<int,int>, pair<int,int> > make_ans(seg x)
{
    pair<int,int> p1 = {x.a,x.b};
    pair<int,int> p2 = {x.c,x.d};
    pair< pair<int,int>, pair<int,int> > res = {p1,p2};
    return res;
}

void pre()
{
    make_ots();
    int idx = 0;
    for(int i = 0; i < 7; i++)
    {
        for(int j = 0; j < 4; j++)
        {
            seg x = ots[i][j];
            pos[idx] = x;
            mymap[make_ans(x)] = idx;
            mymap[make_ans({x.c,x.d,x.a,x.b})] = idx;
            idx++;
        }
    }
}

bool f = false;
std::vector <std::pair <std::pair <int, int>, std::pair <int,int>>> mark_card (int k)
{
    if(!f)
    {
        pre();
        f = true;
    }
    vector< pair< pair<int,int>, pair<int,int> > >ans;

    for(int j = 0; j < 28; j++)
    {
        if(k&(1<<j)) ans.push_back(make_ans(pos[j]));
    }
    return ans;
}

int tell_card (std::vector <std::pair <std::pair <int, int>, std::pair <int, int>>> card)
{
    int k = 0;
    for(pair<pair<int,int>,pair<int,int>> nb : card)
    {
        int j = mymap[nb];
        k += (1<<j);
    }
    return k;
}
