#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int maxn = 1.5e5 + 10;

int n, m, c[maxn], d[maxn];

vector < int > adj[maxn];
void input()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
        cin >> c[i];
    for (int i = 1; i <= n; i ++)
        cin >> d[i];
    for (int i = 1; i <= m; i ++)
    {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
}

void clear_data()
{
    for (int i = 1; i <= n; i ++)
    {
        adj[i].clear();
    }
}

bool possible[maxn];
int used[maxn];
void simulate()
{
    for (int i = 1; i <= n; i ++)
        possible[i] = 0;

    for (int t = 1; t <= n; t ++)
    {
        for (int i = 1; i <= n; i ++)
        {
            used[i] = 0;
        }

        queue < int > q;
        for (int i = 1; i <= n; i ++)
        {
            if (c[i] == t && d[i] <= t)
            {
                used[i] = 1;
                q.push(i);
            }
        }

        while(!q.empty())
        {
            int v = q.front();
            q.pop();

            for (int u : adj[v])
            {
                if (used[u] == 0 && d[u] <= t && c[u] >= t)
                {
                    used[u] = 1;
                    q.push(u);
                }
            }
        }

        for (int i = 1; i <= n; i ++)
        {
            if (d[i] == t && used[i] == 1)
                possible[i] = 1;
        }
    }

    bool done = true;
    for (int i = 1; i <= n; i ++)
    {
        if (possible[i] == false)
        {
            done = false;
            break;
        }
    }

    cout << done << endl;
}
void solve()
{
    input();
    simulate();
    clear_data();    
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
/**
2
4 4
3 3 2 1
2 1 2 1
1 2
2 3
3 4
4 2
4 4
3 3 2 1
1 2 2 1
1 2
2 3
3 4
4 2

*/