#include<iostream>
#include<vector>

bool init_done = false;

std::vector < std::pair < std::pair < int, int >, std::pair < int, int > > > valid_lines;

void add_line(int x1, int y1, int x2, int y2)
{
    valid_lines.push_back({{x1, y1}, {x2, y2}});
}
void init()
{
    add_line(0, 0, 0, 1);
    add_line(0, 0, 1, 2);
    add_line(0, 0, 1, 1);
    add_line(0, 0, 2, 1);
    add_line(0, 0, 1, 0);

    add_line(0, 1, 0, 2);
    add_line(0, 1, 1, 2);
    add_line(0, 1, 2, 2);
    add_line(0, 1, 1, 1);
    add_line(0, 1, 2, 0);
    add_line(0, 1, 1, 0);

    add_line(0, 2, 1, 2);
    add_line(0, 2, 2, 1);
    add_line(0, 2, 1, 1);
    add_line(0, 2, 1, 0);

    add_line(1, 2, 2, 2);
    add_line(1, 2, 2, 1);
    add_line(1, 2, 2, 0);
    add_line(1, 2, 1, 1);
    
    add_line(2, 2, 2, 1);
    add_line(2, 2, 1, 0);
    add_line(2, 2, 1, 1);
    
    add_line(2, 1, 2, 0);
    add_line(2, 1, 1, 0);
    add_line(2, 1, 1, 1);

    add_line(2, 0, 1, 0);
    add_line(2, 0, 1, 1);

    add_line(1, 0, 1, 1);
}
std::vector <std::pair <std::pair <int, int>, std::pair <int, int>>> mark_card (int k) 
{
    if (!init_done)
    {
        init();
        init_done = true;
    }

    std::vector <std::pair <std::pair <int, int>, std::pair <int, int>>> res;
    for (int i = 0; i < k; i ++)
    {
        res.push_back(valid_lines[i]);
    }
    return res;
}

int tell_card (std::vector <std::pair <std::pair <int, int>, std::pair <int, int>>> card) 
{
    return card.size();
}
