#include<iostream>
#include<vector>
#include <bits/stdc++.h>

bool init_done = false;
using namespace std;
std::vector < std::pair < std::pair < int, int >, std::pair < int, int > > > valid_lines;

void add_line(int x1, int y1, int x2, int y2)
{
    valid_lines.push_back(std::make_pair(std::make_pair(x1, y1), std::make_pair(x2, y2)));
}

std::map < std::pair < int, int >, std::pair < int, int > > rot;

std::map < std::pair < std::pair < int, int >, std::pair < int, int > >, int > val;
void init()
{
    add_line(0, 0, 0, 1);
    add_line(0, 0, 1, 2);
    add_line(0, 0, 1, 1);
    add_line(0, 0, 2, 1);
    add_line(0, 0, 1, 0);

    add_line(0, 1, 0, 2);
    add_line(0, 1, 1, 2);
    add_line(0, 1, 2, 2);
    ///add_line(0, 1, 1, 1);
    add_line(0, 1, 2, 0);
    add_line(0, 1, 1, 0);

    add_line(0, 2, 1, 2);
    add_line(0, 2, 2, 1);
    add_line(0, 2, 1, 1);
    add_line(0, 2, 1, 0);

    add_line(1, 2, 2, 2);
    add_line(1, 2, 2, 1);
    add_line(1, 2, 2, 0);
    ///add_line(1, 2, 1, 1);
    
    add_line(2, 2, 2, 1);
    add_line(2, 2, 1, 0);
    add_line(2, 2, 1, 1);
    
    add_line(2, 1, 2, 0);
    add_line(2, 1, 1, 0);
    ///add_line(2, 1, 1, 1);

    add_line(2, 0, 1, 0);
    add_line(2, 0, 1, 1);

    ///add_line(1, 0, 1, 1);
    std::pair < std::pair < int, int >, std::pair < int, int > > cur;
    for (int i = 0; i < (int)(valid_lines.size()); i ++)
    {
        cur = valid_lines[i];
        if (cur.first > cur.second)
            std::swap(cur.first, cur.second);
        valid_lines[i] = cur;
        val[cur] = (1 << i);
    }

    rot[{0, 0}] = {2, 0};
    rot[{1, 0}] = {2, 1};
    rot[{2, 0}] = {2, 2};
    rot[{0, 1}] = {1, 0};
    rot[{1, 1}] = {1, 1};
    rot[{2, 1}] = {1, 2};
    rot[{0, 2}] = {0, 0};
    rot[{1, 2}] = {0, 1};
    rot[{2, 2}] = {0, 2};
}


std::vector <std::pair <std::pair <int, int>, std::pair <int, int>>> mark_card (int k) 
{
    if (!init_done)
    {
        init();
        init_done = true;
    }

    std::vector <std::pair <std::pair <int, int>, std::pair <int, int>>> res;
    for (int i = 0; i < k/**(int)valid_lines.size()*/; i ++)
    {
        ///if ((k & (1 << (i))) > 0)
        {
           // assert(val[valid_lines[i]] == (1 << i));
            res.push_back(valid_lines[i]);
        }
    }
    res.push_back(std::make_pair(std::make_pair(1, 0), std::make_pair(1, 1)));
    return res;
}

int tell_card (std::vector <std::pair <std::pair <int, int>, std::pair <int, int>>> card) 
{
    return card.size() - 1;
    std::pair < int, int > spec = std::make_pair(- 1, - 1);
    for (int i = 0; i < (int)(card.size()); i ++)
    {
        if (card[i].second == std::make_pair(1, 1))
            std::swap(card[i].first, card[i].second);

        if (card[i].first == std::make_pair(1, 1))
        {
            int dx = card[i].second.first - 1, dy = card[i].second.second - 1;
            if (dx < 0)
                dx *= -1;
            if (dy < 0)
                dy *= -1;
            //std::cout << "HERE " << dx << " " << dy << std::endl;
            if (dx + dy == 1)
                spec = card[i].second;
        }
    }

    //std::cout << spec.first << " " << spec.second << std::endl;

    int tp;
    if (spec == std::make_pair(1, 0))
        tp = 0;
    else
    if (spec == std::make_pair(0, 1))
        tp = 1;
    else
    if (spec == std::make_pair(1, 2))
        tp = 2;
    else
    if (spec == std::make_pair(2, 1))
        tp = 3;
    else
    {
        assert(false);
    }
    //std::cout << "TP " << tp << std::endl;

    for (int t = 0; t < tp; t ++)
    {
        for (int i = 0; i < (int)(card.size()); i ++)
        {
            std::pair < std::pair < int, int >, std::pair < int, int > > cur = card[i];
            cur.first = rot[cur.first];
            cur.second = rot[cur.second];
            if (cur.first > cur.second)
                std::swap(cur.first, cur.second);
            card[i] = cur;
        }
    }



    int value = 0;
    for (int i = 0; i < (int)(card.size()); i ++)
    {
        std::pair < std::pair < int, int >, std::pair < int, int > > cur = card[i];
        //std::cout << "card " << cur.first.first << " " << cur.first.second << " ";
        //std::cout << cur.second.first << " " << cur.second.second << std::endl;
        value = value + val[cur];
        swap(cur.first, cur.second);
        value = value + val[cur];
    }
    //std::cout << "value " << value << std::endl;
    return value;
}
