#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

long long n, d, mod=1e9+7;
vector<int> gr[100005];
bool used[100005];
int par[100005];
long long tpos[100005], sumpval[100005], sumgval[100005];

void dfs(int v)
{
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(nv==par[v]) continue;
        par[nv]=v;
        dfs(nv);
        if(!tpos[nv]) tpos[v]++;
    }

    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(nv==par[v]) continue;
        if(tpos[nv]==1) sumpval[v]+=sumgval[nv];
        else if(tpos[nv]==0) sumgval[v]+=sumpval[nv];
    }
    if(tpos[v]==0) sumpval[v]++;
}

long long sumpechpos=0, sumgubpos=0;
long long brpechpos=0, brgubpos=0;

void dfs2(int v)
{
    used[v]=1;
    if(!tpos[v]) 
    {
        brgubpos++; 
        sumgubpos+=sumpval[v];
    }
    else 
    {
        brpechpos++; 
        if(tpos[v]==1) sumpechpos+=sumgval[v];
    }
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(used[nv]) continue;
        
        long long v_sumgval=sumgval[v], v_tpos=tpos[v], v_sumpval=sumpval[v];
        long long nv_sumgval=sumgval[nv], nv_tpos=tpos[nv], nv_sumpval=sumpval[nv];
        if(!tpos[nv]) 
        {
            tpos[v]--;
            sumgval[v]-=sumpval[nv];
        }
        else if(tpos[nv]==1)
        {
            sumpval[v]-=sumgval[nv];
        }
        if(!tpos[v]) {tpos[nv]++; if(v_tpos) sumpval[v]++;}

        if(tpos[v]==1) sumpval[nv]+=sumgval[v];
        else if(tpos[v]==0) sumgval[nv]+=sumpval[v];
        if(nv_tpos && !tpos[nv]) sumpval[nv]++;
        
        dfs2(nv);
        sumgval[v]=v_sumgval, tpos[v]=v_tpos, sumpval[v]=v_sumpval;
        sumgval[nv]=nv_sumgval, tpos[nv]=nv_tpos, sumpval[nv]=nv_sumpval;
    }
}

void solve()
{
    for(int i=0; i<n-1; i++)
    {
        int v1, v2;
        cin>>v1>>v2;
        gr[v1].push_back(v2);
        gr[v2].push_back(v1);
    }
    dfs(1);
    dfs2(1);
    brpechpos%=mod;
    brgubpos%=mod;
    sumpechpos%=mod;
    sumgubpos%=mod;
    if(tpos[1]>=2) cout<<n*n%mod<<endl;    
    else if(tpos[1]==1)
    {
        long long brpob=0;
        brpob+=(n-sumgval[1])*n%mod;
        long long sum=sumgval[1]*brpechpos%mod;
        cout<<(sum+brpob)%mod<<endl;
    }
    else
    {
        long long sum=sumpval[1]*brgubpos%mod;
        cout<<sum%mod<<endl;
    }
}


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>d;
    solve();
    return 0;
}