#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

const long long inf=1e10;
 
struct point{
    long long x,y;
};

struct square{
    long long x,y,l;
};

int n,k;
long long miny,maxy,minx,maxx;
point p[MAXN];

bool cmp(point fr,point sc){
    if(fr.x==sc.x)return fr.y<sc.y;
    return fr.x<sc.x;
}

bool cmp2(point fr,point sc){
    if(fr.y==sc.y)return fr.x<sc.x;
    return fr.y<sc.y;
}

square sol[3];

bool ok(int l,int r,long long len,int s){
    maxx=minx=p[l].x;
    maxy=miny=p[l].y;

    int pt=r;
    for(int f=l;f<=r;f++){
        sol[0]={maxx-len,maxy-len,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){   
            pt=f-1; break;
        }
    }

    if(s==0 and pt!=r and p[pt].x==p[pt+1].x)return false;
    if(s==1 and pt!=r and p[pt].y==p[pt+1].y)return false;

    if(pt==r){
        sol[0]={minx,miny,len};
        return true;
    }
    
    maxx=minx=p[pt+1].x;
    maxy=miny=p[pt+1].y;

    for(int f=pt+1;f<=r;f++){
        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len)break;

        if(f==r){
            sol[1]={minx,miny,len};
            return true;
        }
    }

    return false;
}

bool check2(int l,int r,long long len){
    sol[0]=sol[1]={inf,inf,inf};

    sort(p+l,p+r+1,cmp);
    if(ok(l,r,len,0))return true;

    sort(p+l,p+r+1,cmp2);
    if(ok(l,r,len,1))return true;

    return false;
}

bool check3(long long len){
    sol[0]=sol[1]=sol[2]={inf,inf,inf};

    sort(p+1,p+n+1,cmp);

    maxx=minx=p[1].x;
    maxy=miny=p[1].y;

    for(int f=1;f<=n;f++){
        sol[2]={maxx-len,maxy-len,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){
            if(check2(f,n,len)){
                return true;
            }
            break;
        }

        if(f==n){
            sol[2]={maxx-len,maxy-len,len};
            return true;
        }
    }

    sort(p+1,p+n+1,cmp);   
    reverse(p+1,p+n+1); 

    maxx=minx=p[1].x;
    maxy=miny=p[1].y;

    for(int f=1;f<=n;f++){
        sol[2]={minx,miny,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){
            if(check2(f,n,len)){
                return true;
            }
            break;
        }

        if(f==n){
            sol[2]={maxx-len,maxy-len,len};
            return true;
        }
    }


    sort(p+1,p+n+1,cmp2);

    maxx=minx=p[1].x;
    maxy=miny=p[1].y;

    for(int f=1;f<=n;f++){
        sol[2]={maxx-len,maxy-len,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){
            if(check2(f,n,len)){
                return true;
            }
            break;
        }

        if(f==n){
            sol[2]={maxx-len,maxy-len,len};
            return true;
        }
    }

    sort(p+1,p+n+1,cmp2);   
    reverse(p+1,p+n+1); 

    maxx=minx=p[1].x;
    maxy=miny=p[1].y;

    for(int f=1;f<=n;f++){
        sol[2]={minx,miny,len};

        maxx=max(maxx,p[f].x);
        minx=min(minx,p[f].x);

        maxy=max(maxy,p[f].y);
        miny=min(miny,p[f].y);

        if(max(maxx-minx,maxy-miny)>len){
            if(check2(f,n,len)){
                return true;
            }
            break;
        }

        if(f==n){
            sol[2]={maxx-len,maxy-len,len};
            return true;
        }
    }

    return false;
}

bool intersec(square fr,square sc){
    if(fr.x==inf or sc.x==inf)return false;

    return (sc.x>=fr.x and sc.y>=fr.y and sc.x<=fr.x+fr.l and sc.y<=fr.y+fr.l) or (fr.x>=sc.x and fr.y>=sc.y and fr.x<=sc.x+sc.l and fr.y<=sc.y+sc.l);
}

void solve2(){
    long long l=0,r=inf,tt;
    
    while(l+1<r){
        tt=(l+r)/2;
        if(check2(1,n,tt)){
            r=tt;
        }else{
            l=tt;
        }
    }

    check2(1,n,r);
    if(intersec(sol[0],sol[1]))cout<<1/0;

    for(int i=0;i<2;i++){
        if(sol[i].x==inf){
            cout<<-3000000000<<" "<<-3000000000+2*i<<" "<<1<<"\n";
        }else cout<<sol[i].x<<" "<<sol[i].y<<" "<<max(1LL,sol[i].l)<<"\n";
    }   
}

void solve3(){
    long long l=0,r=inf,tt;
    
    while(l+1<r){
        tt=(l+r)/2;
        if(check3(tt)){
            r=tt;
        }else{
            l=tt;
        }
    }

    check3(r);

    if(intersec(sol[0],sol[1]))cout<<1/0;
    if(intersec(sol[0],sol[2]))cout<<1/0;
    if(intersec(sol[1],sol[2]))cout<<1/0;

    for(int i=0;i<3;i++){
        if(sol[i].x==inf){
            cout<<-3000000000<<" "<<-3000000000+2*i<<" "<<1<<"\n";
        }else cout<<sol[i].x<<" "<<sol[i].y<<" "<<max(1LL,sol[i].l)<<"\n";
    }
}

void solve1(){
    maxx=minx=p[1].x;
    maxy=miny=p[1].y;

    for(int i=1;i<=n;i++){
        maxx=max(maxx,p[i].x);
        minx=min(minx,p[i].x);

        maxy=max(maxy,p[i].y);
        miny=min(miny,p[i].y);
    }

    cout<<minx<<" "<<miny<<" "<<max(max(1LL,maxx-minx),maxy-miny)<<"\n";
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<=n;i++){
        cin>>p[i].x>>p[i].y;
    }

    if(k==1)solve1();
    if(k==2)solve2();
    if(k==3)solve3();


    return 0;
}