#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

int n,a[MAXN];
int fenwick[MAXN],cnt,pr[MAXN],nxt[MAXN];
vector<int> w;
unordered_map<int,int> mp;
long long ans;

void update(int x){
    while(x<=n){
        fenwick[x]++;
        x+=(x & (-x));
    }
}

int getsum(int x){
    int res=0;
    while(x>=1){
        res+=fenwick[x];
        x-=(x & (-x));
    }
    return res;
}

void movet(int x,int y){
    if(x==y)return;

    ans+=abs(y-x);

    int dx=(y-x)/abs(y-x),s=a[x];

    for(int i=x;i!=y;i+=dx){
        a[i]=-a[i+dx];
    }

    a[y]=s;
}

void solve(int l,int r){
    if(l==r)return;

    int opt=l;
    for(int i=l;i<=r;i++){
        if(abs(a[i])>abs(a[opt]))opt=i;
    }

    int maxs=a[opt];

    if(a[opt]>0){
        if((opt-l)%2==1 and (r-opt)%2==0){
            if(opt-l<r-opt)movet(opt,l);
            else movet(opt,r);
        }else if((opt-l)%2==1)movet(opt,l);
        else if((r-opt)%2==0)movet(opt,r);
        else{
            cout<<"-1\n";
            exit(0);
        }
    }else{
        if((opt-l)%2==0 and (r-opt)%2==1){
            if(opt-l<r-opt)movet(opt,l);
            else movet(opt,r);
        }else if((opt-l)%2==0)movet(opt,l);
        else if((r-opt)%2==1)movet(opt,r);
        else{
            cout<<"-1\n";
            exit(0);
        }
    }

    if(a[l]==maxs)solve(l+1,r);
    else solve(l,r-1);    
}

int main(){

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }

    solve(1,n);

    cout<<ans<<"\n";

    return 0;
}