#include<bits/stdc++.h>
#define MAXN 150007
using namespace std;

int t,n,m,a,b;
pair<int,int> c[MAXN],d[MAXN];
vector<int> v[MAXN];
bool ban[MAXN];
int li[MAXN],tim;

void reset(){
    for(int i=1;i<=n;i++){
        ban[i]=true;
        v[i].clear();
    }
}

void add(int x){
    ban[x]=false;
}

void rem(int x){
    ban[x]=true;
}

bool dfs(int x,int y){
    if(x==y)return true;

    li[x]=tim;
    for(int i=0;i<v[x].size();i++){
        if(li[v[x][i]]==tim or ban[v[x][i]])continue;

        if(dfs(v[x][i],y))return true;
    }

    return false;
}

bool path(int x,int y){
    tim++;

    return dfs(x,y);
}

void solve(){
    cin>>n>>m;

    reset();

    for(int i=1;i<=n;i++){
        cin>>c[i].first;
        c[i].second=i;
    }
    for(int i=1;i<=n;i++){
        cin>>d[i].first;
        d[i].second=i;
    }

    sort(c+1,c+n+1);
    sort(d+1,d+n+1);

    for(int i=1;i<=m;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    int pt=n;
    for(int i=n;i>=1;i--){
        while(pt>=1 and c[pt].first>=d[i].first){
            add(c[pt].second); pt--;
        }

        for(int f=i;f>=1 and d[f].first==d[i].first;f--){
            bool dali=false;

            for(int k=pt+1;k<=n and c[k].first==d[f].first;k++){
                if(path(c[k].second,d[f].second)){
                    dali=true; break;
                }
            }

            if(!dali){
                cout<<0<<"\n";
                return;
            }
        }

        for(int f=i;f>=1 and d[f].first==d[i].first;f--){
            rem(d[f].second);
            i=f;
        }
    }

    cout<<1<<"\n";
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>t;
    for(int i=1;i<=t;i++){
        solve();
    }

    return 0;
}