#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

struct Point
{
    long long x,y;
    Point(){};
    Point(long long x, long long y) : x(x), y(y) {}

};

const int maxn = 1e5+5;

long long n,k;
Point p[maxn];
long long inf = 3e9;

void solve1()
{
    Point minn,maxx;
    minn = {inf,inf};
    maxx = {-inf,-inf};
    for(int i = 1; i <= n; i++)
    {
        minn.x = min(minn.x,p[i].x);
        minn.y = min(minn.y,p[i].y);

        maxx.x = max(maxx.x,p[i].x);
        maxx.y = max(maxx.y,p[i].y);
    }
    long long l = maxx.x-minn.x;
    if(maxx.y-minn.y > l) l = maxx.y-minn.y;
    l = max(l,(long long) 1);
    cout << minn.x << " " << minn.y << " " << l << endl;
    exit(0);
}

bool cmpx(Point p1, Point p2)
{
    if(p1.x==p2.x) return p1.y < p2.y;
    return p1.x < p2.x;
}

bool cmpy(Point p1, Point p2)
{
    if(p1.y==p2.y) return p1.x < p2.x;
    return p1.y < p2.y;
}

Point minOP(Point a, Point b)
{
    Point res;
    res.x = min(a.x,b.x);
    res.y = min(a.y,b.y);
    return res;
}

Point maxOP(Point a, Point b)
{
    Point res;
    res.x = max(a.x,b.x);
    res.y = max(a.y,b.y);
    return res;
}

Point maxp[maxn],minp[maxn];

Point maxs[maxn],mins[maxn];

vector<pair<Point,long long> > make_ans()
{
    minp[0] = {inf,inf};
    maxp[0] = {-inf,-inf};
    for(int i = 1; i <= n; i++)
    {
        minp[i] = minp[i-1];
        maxp[i] = maxp[i-1];
        minp[i] = minOP(minp[i],p[i]);
        maxp[i] = maxOP(maxp[i],p[i]);
    }

    mins[n+1] = {inf,inf};
    maxs[n+1] = {-inf,-inf};
    for(int i = n; i >= 1; i--)
    {
        mins[i] = mins[i+1];
        maxs[i] = maxs[i+1];
        mins[i] = minOP(mins[i],p[i]);
        maxs[i] = maxOP(maxs[i],p[i]);
    }

    long long l = 2*inf+1;
    int idx = 0;
    for(int i = 1; i < n; i++)
    {
        if(maxp[i].x < mins[i+1].x || maxp[i].y < mins[i+1].y)
        {
            long long l1 = max(maxp[i].x-minp[i].x, maxp[i].y-minp[i].y);
            long long l2 = max(maxs[i+1].x-mins[i+1].x, maxs[i+1].y-mins[i+1].y);
            if(max(l1,l2) < l)
            {
                l = max(l1,l2);
                idx = i;
            }
        }
    }

    vector<pair<Point,long long> > ans;
    int i = idx;
    if(i == 0) return ans;
    long long l1 = max(maxp[i].x-minp[i].x, maxp[i].y-minp[i].y);
    long long l2 = max(maxs[i+1].x-mins[i+1].x, maxs[i+1].y-mins[i+1].y);
    ans.push_back({minp[i],l1});
    ans.push_back({mins[i+1],l2});
    return ans;
}

void print(vector<pair<Point,long long> > ans)
{
    for(int j = 0; j < ans.size(); j++)
    {
        pair<Point,long long> nb = ans[j];
        if(j==0)
        {
            if(!nb.second)
            {
                nb.first.x--;
                nb.first.y--;
                nb.second = 1;
            }
        }
        else
        {
            if(!nb.second) nb.second = 1;
        }
        cout << nb.first.x << " " << nb.first.y << " " << nb.second << endl;
    }
}

void solve2()
{
    sort(p+1,p+n+1,cmpx);
    vector<pair<Point,long long> > ans1 = make_ans();
    sort(p+1,p+n+1,cmpy);
    vector<pair<Point,long long> > ans2 = make_ans();
    if(ans1.size()==0 && ans2.size()==0)
    {
        cout << inf << " " << inf << " " << 1 << endl;
        solve1();
        exit(0);
    }
    if(ans1.size()==0) print(ans2);
    else if (ans2.size()==0) print(ans1);
    else
    {
        if(max(ans1[0].second,ans1[1].second) < max(ans2[0].second,ans2[1].second)) print(ans1);
        else print(ans1);
    }
    exit(0);
}

void solve3()
{



    exit(0);
}


void read()
{
    cin >> n >> k;
    for(int i = 1; i <= n; i++) cin >> p[i].x  >> p[i].y;
    if(k==1) solve1();
    if(k==2) solve2();
    if(k==3) solve3();
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
return 0;
}
