#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const long long mod = 1e9+7;
const int maxn = 1e5+5;

long long n,d;
vector<int>g[maxn];

void read()
{
    cin >> n >> d;
    int a,b;
    for(int i = 1; i < n; i++)
    {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
}

bool dp[maxn];

void dfs_dp(int beg, int par)
{
    if(beg==n+1) return;
    dp[beg] = 0;
    for(int nb : g[beg])
    {
        if(nb==par) continue;
        dfs_dp(nb,beg);
        if(!dp[nb]) dp[beg] = true;
    }
}

long long sluch[2];

void solve()
{
    dfs_dp(1,1);

    for(int i = 1; i <= n; i++) sluch[dp[i]]++;
    long long ans = 0;

    for(int i = 1; i <= n; i++)
    {
        g[i].push_back(n+1);

        dp[n+1] = 0;
        dfs_dp(1,1);
        if(dp[1]) ans += sluch[0];

        dp[n+1] = 1;
        dfs_dp(1,1);
        if(dp[1]) ans += sluch[1];

        g[i].pop_back();

        ans %= mod;
    }
    cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	read();
	solve();
return 0;
}
